
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "election_def.h"


unsigned int str_to_int (const char *str) {
    unsigned value = 0u, tmp = 0u;
    int size = sizeof(int) / sizeof(char);
    int len = strlen(str);

    while (len >= size) {
        value ^= *(unsigned *)str;
        str += size;
        len -= size;
    }
    if (len > 0) {

        strcpy( (char *)&tmp, str);
        value ^= tmp;
    }
    return (value);
}

unsigned hash (int batch, int pindex) {
    char h_str[HSTR_LEN];
    unsigned int val;

    sprintf(h_str, "%d%d", batch, pindex);
    val = str_to_int(h_str);
    return ( (val*HASH_MULT) >> SHIFT_AMT);
}


ballotList retrieve(electionDef *myE, int batch, int pindex) {
    ballotList list_a = myE->ballots[hash(batch, pindex)];

    for ( ; list_a != EMPTY_LIST; list_a = list_a->next) {
        if (batch == list_a->batch && pindex == list_a->pindex) {
            return (list_a);
        }
    }

    return (EMPTY_LIST);

}




int new_entry(electionDef *myE, int batch, int pindex, int pref, int ccode, int pcode) {

    int i;
    
    ballotList b = retrieve(myE, batch, pindex);

    ballotList tmp;
    unsigned hashcode ;

    if (b != EMPTY_LIST ) {

    //    printf("Update hash entry\n");

        while (b != EMPTY_LIST) {

            if (b->batch == batch && b->pindex == pindex) {

                if (b->orderedVotes[pref].ccode != -1 || b->orderedVotes[pref].pcode != -1) {
                 
                    b->orderedVotes[pref].ccode = -1;
                    b->orderedVotes[pref].pcode = -1;
                    
                   // printf("Excluding parts of ballot %d,%d (below pref %d)\n", batch, pindex, pref);
                    
                    return(0);
                }
                
                b->orderedVotes[pref].ccode = ccode;
                b->orderedVotes[pref].pcode = pcode;
                
                return (0);
            }
        }
    }

    /* If we get here, the ballot is not already in the hash table */

    hashcode = hash(batch, pindex);
    b = myE->ballots[hashcode];

    tmp = malloc (sizeof(ballotDef));

    for (i = 1 ; i < MAXCAND ; i++) {
        tmp->orderedVotes[i].ccode = -1;
        tmp->orderedVotes[i].pcode = -1;
    }
    
    tmp->batch = batch;
    tmp->pindex = pindex;
    tmp->orderedVotes[pref].ccode = ccode;
    tmp->orderedVotes[pref].pcode = pcode;
        
    tmp->next = b;
    myE->ballots[hashcode] = tmp;

        
    return (0);

}

